	TITLE UNDELETE(EXE)
	.MODEL	SMALL
	.STACK	64
GETPSP MACRO
	MOV	CX,000EH
	MOV	SI,5DH
	LEA	DI,BUFFER
	REP	MOVSB
ENDM
PRINT MACRO STRING
	MOV	AH,09H
	LEA	DX,STRING
	INT 	21H
ENDM
PRINT2 MACRO STRING,NUM
	MOV	AH,40H
	MOV	BX,01H
	MOV	CX,NUM
	LEA	DX,STRING
	INT 	21H
ENDM
INPUT MACRO
	MOV	AH,10H
	INT	16H
	CMP	AL,'Q'
	JE	EXITS
	CMP	AL,'Y'
ENDM
WRITE MACRO	LOC,VAL
	LOCAL	EVENW
	LOCAL	ENDNW

	PUSHA

	LEA	DI,IOBUFFR
	MOV	Ax,LOC
	SHL	AX,1
	ADD	AX,LOC
	SHR	AX,1
	ADD	DI,AX
	MOV	EBX,[DI]
	MOV	DX,LOC
	TEST	DX,1
	JZ	EVENNO

	AND	EBX,0FH
	MOV	EDX,0
	MOV	DX,VAL
	SHL	EDX,4
	OR	EBX,EDX
	JMP	ENDNOW
	
EVENW:	
	AND	EBX,0F000H
	MOV	EDX,0
	MOV	DX,VAL
	OR	EBX,EDX
	
ENDNW:	MOV	[DI],EBX

	POPA
ENDM

	.DATA	
;---------------------------------------------------------------------------------
ARRAYS	DB 30 DUP(0),'$'
NUMENT	DB 0,'$'

BUFFER	DB 15 DUP(?),'$'

RDBLOCK	DB 0
RDHEAD	DW 0
RDCYLND	DW 0
RDSECT	DW 19
RDNOSEC	DW 2
RDBUFFR	DW IOBUFFR
	DW SEG _DATA
IOBUFFR DB 1024 DUP(' '),'$'


SCBLOCK	DB 0
SCHEAD	DW 0
SCCYLND	DW 0
SCSECT	DW 33
SCNOSEC	DW 1
SCBUFF	DW SCBUFFR
	DW SEG _DATA
SCBUFFR DB 512 DUP(' '),'$'

FILE	DB 11 DUP(' '),'$'
ERROR 	DB '***FILE NOT FOUND***','$'
FSIZE	DD 0
SCLUS 	DW 2
NCLUS	DB 0
PROMPT 	DB 0AH,0DH,0AH,0DH,'*** IS THIS THE CONTENT OF YOUR FILE[Y/N/Q]? ***',0AH,0DH,0AH,0DH,'$'
ALLOK	DB 0AH,0DH,0AH,0DH,'RECOVERING FILE... PLEASE WAIT...',0AH,0DH,'$'
LOCA	DW ?
VALA	DW ?
;---------------------------------------------------------------------------------
	.CODE
	.386
MAIN	PROC	FAR
	
	MOV	AX,@data
	MOV	ES,AX
	
	GETPSP
	
	MOV	DS,AX
	
	CALL READDIR
	CALL SEARCH
			
	MOV	AX,4C00H
	INT	21H
	
MAIN	ENDP

READDIR	PROC 	NEAR
	MOV	AX,440DH
	MOV	BX,01
	MOV	CH,08
	MOV	CL,61H
	LEA	DX,RDBLOCK
	INT 	21H
	RET
READDIR	ENDP
WRITEDIR PROC	NEAR
	MOV	AX,440DH
	MOV	BX,01
	MOV	CH,08
	MOV	CL,41H
	LEA	DX,RDBLOCK
	INT 	21H
	RET
WRITEDIR ENDP
READFAT PROC	NEAR
	MOV	RDSECT,01H
	CALL READDIR
	RET
READFAT ENDP
WRITEFAT PROC	NEAR
	MOV	RDSECT,01H
	CALL WRITEDIR
	RET
WRITEFAT ENDP
READSEC	PROC 	NEAR
	MOV	AX,440DH
	MOV	BX,01
	MOV	CH,08
	MOV	CL,61H
	LEA	DX,SCBLOCK
	INT 	21H
	RET
READSEC	ENDP

WRITESEC PROC	NEAR
	MOV	AX,440DH
	MOV	BX,01
	MOV	CH,08
	MOV	CL,41H
	LEA	DX,SCBLOCK
	INT 	21H
	RET
WRITESEC ENDP

SEARCH PROC	NEAR
	MOV	CX,11
	LEA	SI,BUFFER
	LEA 	DI,FILE
	REP	MOVSB
	MOV	FILE,0E5H
		
	LEA	SI,IOBUFFR-20H
	PUSH	SI
	MOV	BX,20H
	
S10:	MOV	CX,11
	POP	SI
	ADD	SI,20H
	PUSH	SI
	LEA	DI,FILE
	DEC	BX
	JZ	S20
	REPE	CMPSB
	JNE	S10
	MOV	AL,BUFFER
	POP	SI
	MOV	[SI],AL
	CALL WRITEDIR	


	ADD	SI,1AH
	MOV	CX,[SI]
	MOV	WORD PTR SCLUS,CX
	ADD 	SI,02H
	MOV	ECX,[SI]
	MOV	DWORD PTR FSIZE,ECX
	CMP	FSIZE,200H
	JG	S15
	
	CALL READFAT
	LEA	DI,IOBUFFR
	MOV	AX,SCLUS
	SHL	AX,1
	ADD	AX,SCLUS
	SHR	AX,1
	ADD	DI,AX
	MOV	EBX,[DI]
	AND	SCLUS,1
	JZ	EVENNO
	OR	EBX,0FFF0H
	JMP	ENDNOW
	
EVENNO:	OR	EBX,0FFFH
	
ENDNOW:	MOV	[DI],EBX
	CALL WRITEFAT
	RET
S15:	
	CALL READFAT
	
	MOV	EDX,FSIZE
	SHR	EDX,16
	MOV	EAX,FSIZE
	MOV	BX,200H
	IDIV	BX
	MOV	NCLUS,AL
	
	MOV	AX,SCLUS
	ADD	AX,30
	MOV	SCSECT,AX
	MOV	CL,NCLUS
	MOV	CH,0
	LEA	SI,ARRAYS
NEXT:	
	PUSH	CX
	INC	SCSECT
	CALL READSEC
	
	PRINT2 SCBUFFR,200H
	PRINT PROMPT
	POP	CX
	INPUT
	JNE	NEXT
	MOV	AX,SCSECT
	SUB	AX,31
	MOV	BYTE PTR [SI],AL
	INC	SI
	INC	NUMENT
	LOOP	NEXT

	PRINT	ALLOK
	CALL	RECOVER
	CALL	WRITEFAT
	RET	
S20:
	POP	SI
	PRINT ERROR
EXITS:
	MOV	AX,4C01H
	INT	21H
SEARCH ENDP

RECOVER	PROC	NEAR
	MOV	CL,NUMENT
	MOV	CH,0
	DEC	CX
	LEA	DI,ARRAYS
SLOOP:
	INC	DI
	MOV	AH,0
	MOV	AL,[DI]
	MOV	VALA,AX
	DEC	DI
	MOV	AL,[DI]
	MOV	LOCA,AX
	WRITE	LOCA,VALA
	INC	DI
	LOOP	SLOOP

	MOV	AL,[DI]
	MOV	AH,0
	MOV	LOCA,AX
	WRITE	LOCA,0FFFH

	RET
RECOVER	ENDP
	END MAIN

